<?php

/* contacts.php: E-mail Address book
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: contacts.php,v 1.77 2005/12/19 17:21:52 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'contacts');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}


/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for keep as new setting */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder'], false, true);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* check for contact sort order flags */
if (isset($hm_input['sort_by'])) {
    $_SESSION['contact_sort'] = $hm_input['sort_by'];
}

/* get unseen status */
$unseen = hm_unseen_status($imap_stream, $_SESSION['folders']);

/* defaults */
$addy = '';
$name = '';
$info = '';
$update = false;
$update_index = false;

/* adding from the message view page */
if (isset($hm_input['prep'])) {
    $addy = hm_htmlize($hm_input['prep_addy']);
    if (isset($hm_input['name'])) {
        $name = $hm_input['name'];
    }
    else {
        $name = $addy;
    }
}

/* if adding an address */
if (isset($hm_input['add']) || isset($hm_input['update'])) {
    $addy = $hm_input['addresses'];
    $addy = str_replace(array("\n", "\r", ','), ' ', $addy);
    $addy = preg_replace("/\s{2,}/", ' ', $addy);
    $addy = trim($addy);
    $addy = implode(', ', split(' ', $addy));
    
    if ($str['charset'] == 'UTF-8') {
        $name = utf8_encode($hm_input['name']);
        $info = utf8_encode($hm_input['info']);
    }
    else {
        $name = $hm_input['name'];
        $info = $hm_input['info'];
    }
    if ($addy == '') {
        $_SESSION['notices'][] = $str[159];
        if (isset($hm_input['update'])) {
            $update_index = $hm_input['update_index'];
            $update = true;
        }
    }
    elseif ($name == '') {
        $_SESSION['notices'][] = $str[158];
        if (isset($hm_input['update'])) {
            $update_index = $hm_input['update_index'];
            $update = true;
        }
    }
    elseif (strstr($addy.$name.$info, '|')) {
        $_SESSION['notices'][] = $str[157];
        if (isset($hm_input['update'])) {
            $update_index = $hm_input['update_index'];
            $update = true;
        }
    }
    elseif (!strstr($addy, '@')) {
        $_SESSION['notices'][] = $str[156];
        if (isset($hm_input['update'])) {
            $update_index = $hm_input['update_index'];
            $update = true;
        }
    }
    else {
        $contacts = hmw_get_contacts($_SESSION['user'], $config);
        if (isset($hm_input['update'])) {
            $contacts[$hm_input['update_index']] = 
                array($hm_input['update_index'], $addy, $name, $info);
            $write = hmw_write_contacts($_SESSION['user'], $config, $contacts);
            if (!$write) {
                $_SESSION['notices'][] = $str[153];
                $update_index = $hm_input['update_index'];
                $update = true;
            }
            else {
                $addy = '';
                $name = '';
                $info = '';
                $_SESSION['notices'][] = $str[152];
            }
        }
        elseif (isset($hm_input['add'])) {
            $index = count($contacts);
            $new = array($index, $addy, $name, $info);
            array_push($contacts, $new);
            $write = hmw_write_contacts($_SESSION['user'], $config, $contacts);
            if (!$write) {
                $_SESSION['notices'][] = $str[155];
            }
            else {
                $addy = '';
                $name = '';
                $info = '';
                $_SESSION['notices'][] = $str[154];
                if (isset($hm_input['from_message'])) {
                    header('Location:'.$config['hostname'].$config['install_path'].
                       'message.php?mailbox='.$hm_input['mailbox'].'&id='.$hm_input['id'].
                       '&uid='.$hm_input['from_message']);
                        exit;
                }
            }
        }
    }
}
elseif (isset($hm_input['delete'])) {
    if (isset($hm_input['index'])) {
        $contacts = hmw_get_contacts($_SESSION['user'], $config);
        if (isset($contacts[$hm_input['index']])) {
            array_splice($contacts, $hm_input['index'], 1); 
            $write = hmw_write_contacts($_SESSION['user'], $config, $contacts);
            $_SESSION['notices'][] = $str[255];
        }
    }
}
elseif (isset($hm_input['edit'])) {
    if (isset($hm_input['index'])) {
        $contacts = hmw_get_contacts($_SESSION['user'], $config);
        if (isset($contacts[$hm_input['index']])) {
            $addy = $contacts[$hm_input['index']][1];
            $name = $contacts[$hm_input['index']][2];
            $info = $contacts[$hm_input['index']][3];
            $update = true;
            $update_index = $hm_input['index'];
        }
    }
}

/* toolbar */
$page_data = array();
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream, $hm_input['mailbox'],
                                           $unseen, false, $str[146]);

/* form for adding new contacts */
if (isset($hm_input['from_message'])) {
    $page_data['from_message'] = $hm_input['from_message'];
}
else {
    $page_data['from_message'] = false;
}
if ($update) {
    $page_data['lbl_title'] = $str[151];
}
else {
    $page_data['lbl_title'] = $str[148];
}
$page_data['lbl_email_address'] = $str[144];
$page_data['lbl_required'] = $str[142];
$page_data['addy_val'] = hm_htmlize($addy);
$page_data['lbl_name'] = $str[93];
$page_data['name_val'] = hm_htmlize(utf8_decode($name));
$page_data['lbl_information'] = $str[150];
$page_data['lbl_optional'] = $str[143];
$page_data['info'] = hm_htmlize(utf8_decode($info));
$page_data['update'] = $update;
$page_data['lbl_btn_update'] = $str[61];
$page_data['lbl_btn_add'] = $str[43];
if ($update) {
    $page_data['update_index'] = $update_index;
}

/* table of existing contacts */
$page_data['lbl_contact_list'] = $str[147];
$page_data['lbl_address'] = $str[101];
$page_data['lbl_name'] = $str[93];
$page_data['lbl_information'] = $str[149];
$page_data['input_mailbox'] = $hm_input['mailbox'];
$page_data['input_id'] = $hm_input['id'];
$page_data['lbl_link_title'] = $str[332];
$contacts = hmw_get_contacts($_SESSION['user'], $config);
$contacts_data = array();
if (!empty($contacts)) {
    foreach ($contacts as $index => $array) {
        $contacts_data[$index] = array();
        $contacts_data[$index]['address'] = hm_htmlize($array[1]);
        $contacts_data[$index]['full_address'] = urlencode(hm_utf8_to_html(utf8_decode('"'.$array[2].'" '.$array[1])));
        $contacts_data[$index]['name'] = hm_htmlize(utf8_decode($array[2]));
        $contacts_data[$index]['info'] = hm_htmlize(utf8_decode($array[3]));
    }
}
$page_data['contacts_data'] = $contacts_data;
$page_data['lbl_no_contacts'] = $str[160];
$page_data['lbl_delete'] = $str[4];
$page_data['lbl_edit'] = $str[145];
$page_data['lbl_top'] = $str[324];
if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}
$page_data['start_time'] = $start;

hm_imap_logout($imap_stream); 

/* output HTTP headers */
hm_output_http_headers();

/* output page */
if ($simple) {
    hm_output_page($page_data, 'contacts_template.php', 'simple');
}
else {
    hm_output_page($page_data, 'contacts_template.php', $template_set);
}

?>
