<?php

/* new.php: Displays new mail from all folders 
*
    Copyright (C) 2002-2005  Hastymail Development group

    This file is part of Hastymail.

    Hastymail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hastymail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hastymail; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

* $Id: new.php,v 1.167 2005/07/01 16:05:12 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');
$start = hm_time();

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'new');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
if (isset($_SESSION['settings']['template_set'])) {
    $template_set = $_SESSION['settings']['template_set'];
}
elseif (isset($config['template_set']) && $config['template_set'] != '') {
    $template_set = $config['template_set'];
}
else {
    $template_set = 'default';
}


/* some basic init stuff */
$hm_input['id'] = session_id();
$str = $_SESSION['str'];
if (isset($config['client_sort']) && $config['client_sort'] == 'true') {
    $client = true;
}
else {
    $client = false;
}
if (isset($hm_input['sort'])) {
    $sort = $hm_input['sort_type'];
}
elseif (isset($_SESSION['settings']['new_page_sort'])) {
    $sort = $_SESSION['settings']['new_page_sort'];
}
else {
    if (isset($hm_input['sort_type'])) {
        $sort = $hm_input['sort_type'];
    }
    else {
        $sort = 'ARRIVAL';
    }
}
$_SESSION['settings']['new_page_sort'] = $sort;
if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;

/* check for simple option and set flag */
$simple = false;
if ((isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true')
   || (isset($_SESSION['auto_simplify']) && $_SESSION['auto_simplify'] == 'true')) {
    $simple = true;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get folder list */
$dsp_folders = $_SESSION['dsp_folders'];

/* get toggle and folded view status */
$t_all = false;
if (isset($hm_input['toggle_all'])) {
    $t_all = true;
}
$s_all = false;
foreach ($_POST as $name => $val) {
    if (!$s_all && preg_match("/^ta_/", $name)) {
        $s_all = true;
        break;
    }
}

if (isset($hm_input['default'])) {
    $_SESSION['settings']['folded'] = $_SESSION['default_folded'];
}
elseif (isset($hm_input['fold_all']) || isset($hm_input['unfold_all'])) {
    if (isset($hm_input['fold_all'])) {
        foreach ($_SESSION['folders'] as $folder) {
            $_SESSION['settings']['folded'][$folder] = 1;
        }
    }
    else {
        foreach ($_SESSION['folders'] as $folder) {
            if (isset($_SESSION['settings']['folded'][$folder])) {
                unset($_SESSION['settings']['folded'][$folder]);
            }
        }
    }
}
else {
    if (isset($hm_input['fold'])) {
        $_SESSION['settings']['folded'][$hm_input['fold']] = 1;
    }
    elseif (isset($hm_input['unfold'])) {
        if (isset($_SESSION['settings']['folded'][$hm_input['unfold']])) {
            unset($_SESSION['settings']['folded'][$hm_input['unfold']]);
        }
    }
}
if (isset($_SESSION['settings']['folded'])) {
    $folded = $_SESSION['settings']['folded'];
}
else {
    $folded = array();
}

/* process message control action */
$action = false;
switch (true) {
    case isset($hm_input['move2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
        $hm_input['destination'] = $hm_input['destination2'];
    case isset($hm_input['move']):
        $action = 'move';
        break;
    case isset($hm_input['delete2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
        if (isset($hm_input['skip_trash2'])) {
            $hm_input['skip_trash'] = $hm_input['skip_trash2'];
        }
    case isset($hm_input['delete']):
        $action = 'delete';
        break;
    case isset($hm_input['read2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['read']):
        $action = 'read';
        break;
    case isset($hm_input['flag2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['flag']):
        $action = 'flag';
        break;
    case isset($hm_input['unflag2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['unflag']):
        $action = 'unflag';
        break;
    case isset($hm_input['copy2']):
        $hm_input['selection_type'] = $hm_input['selection_type2'];
    case isset($hm_input['copy']):
        $action = 'copy';
        break;
    default:
        break;
}
if ($action) {
    if ($hm_input['selection_type'] == 'page') {
        $sel = false;
        $array = $_SESSION['new_data'];
    }
    elseif ($hm_input['selection_type'] == 'marked') {
        $array = $_POST;
        $sel = true;
    }
    elseif (isset($hm_input['selection_type'])) {
        if (isset($_SESSION['new_data']) && array_key_exists($hm_input['selection_type'], 
            $_SESSION['new_data'])) {
            $array = array($hm_input['selection_type'] => 
                           $_SESSION['new_data'][$hm_input['selection_type']]);
            $sel = false;
        }
    }
    foreach ($array as $name => $value) {
            if ($sel) {
                $name = base64_decode($name);
            }
        if (substr($name, 0, 5) == 'fold_' || !$sel) {
            if ($sel) {
                $fold = substr($name, 5);
            }
            else {
                $fold = $name;
            }
            $dsp_count = count($value);
            if ($dsp_count > 1) {
                $dsp_end = $str[18];
            }
            else {
                $dsp_end = $str[26];
            }
            $dest = false;
            if (isset($hm_input['destination'])) {
                $dest = $hm_input['destination'];
            }
            if ($sel) {    
                $uid_string = $value[0];
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $value);
                }
            }
            else {
                $uids = array_keys($value);
                $uid_string = $uids[0]; 
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $uids);
                }
            }
            hm_select_mailbox($imap_stream, $fold);
            if ($action == 'delete' && isset($hm_input['skip_trash'])) {
                $skip = true;
            }
            else {
                $skip = false;
            }
            $result = hm_message_controls ($action, $imap_stream,
                                           $uid_string, $dest, false, false, $fold, 
                                           $dsp_count, $dsp_end, $skip);
        }
    }
}

/* check for keep as new setting */
if (isset($hm_input['keep_as_new'])) {
    hm_select_mailbox($imap_stream, $hm_input['kan_folder']);
    hm_imap_action($imap_stream, $hm_input['kan_uid'], 'UNREAD', false, false);
}

/* get unseen messages */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders'], true);

/* get headers for unseen messages */
$data = array();
$total_unseen = 0;
$total_viewable_unseen = 0;
$total_unseen_folders = 0;
$unseen_tmp = $unseen;
$parents = array();
foreach ($unseen_tmp as $folder => $new_count) {
    if ($new_count > 0) {
        $total_unseen_folders++;
        $total_unseen += $new_count;
        hm_select_mailbox($imap_stream, $folder);
        if (!$client) {
            list($uid_array, $parent)  = hm_get_sort_info($imap_stream, $sort,
                                        $hm_input['mailbox'], false, 'UNSEEN',
                                        true);
            $parents[$folder] = $parent;
            $uid_list = implode(',', $uid_array);
        }
        else {
            $uid_list = hm_search_mailbox($imap_stream, 'SEARCH UNSEEN');
            if (trim($uid_list) == '') {
                $unseen[$folder] = 0;
            }
            $uid_list = str_replace(' ', ',', trim($uid_list));
        }
        if (!isset($folded[$folder])) {
            $headers = &hm_get_messages($uid_list, $imap_stream);
            $total_viewable_unseen += $new_count;
        }
        else {
            $headers = array_flip(explode(',', $uid_list));
        }
        if ($client) {
            uasort($headers, "hm_date_cmp");
        }
        else {
            $headers_tmp = array();
            foreach ($uid_array as $val) {
                $headers_tmp[$val] = $headers[$val];
            }
            $headers = $headers_tmp;
        }
        $data[$folder] = $headers; 
    }
}

/* check for missing folders */
hm_check_folders($imap_stream);

/* toolbar */
$page_data = array();
if (isset($_SESSION['notices']) && !empty($_SESSION['notices'])) {
    $page_data['notices'] = $_SESSION['notices'];
    $_SESSION['notices'] = array();
}
else {
    $page_data['notices'] = false;
}
list($page_data['td'], $page_data['hd']) = hm_toolbar2($imap_stream, $hm_input['mailbox'],
                                           $unseen, true, $str[10]);

$page_data['nn4'] = isset($_SESSION['nn4_warning']);
$page_data['palm'] = isset($_SESSION['palm']);
$page_data['folder_data'] = $data;
$page_data['sort'] = $sort;
$top_link = false;
$page_data['lbl_default'] = $str[362];
if (isset($_SESSION['settings']['folder_size'])) {
    $page_data['folder_size'] = $_SESSION['settings']['folder_size'];
}
else {
    $page_data['folder_size'] = 140;
}

/* new messages table */
if (count($data) > 0) {
    $page_data['data_found'] = true;
    $page_data['lbl_collapse'] = $str[353];
    $page_data['lbl_expand'] = $str[354];
    $page_data['lbl_unread_messages_in'] = $str[50];
    $page_data['subfolders'] = $str[125];
    $page_data['total_unseen'] = $total_unseen;
    $page_data['total_unseen_folders'] = $total_unseen_folders;
    $page_data['client'] = $client;
    $page_data['lbl_sort'] = $str[17];
    $page_data['sort_types'] = $str['sort_types'];
    $page_data['sort_type'] = $sort;
    $page_data['input_id'] = $hm_input['id'];
    $page_data['input_mailbox'] = $hm_input['mailbox'];
    $dropdown = array();
    $dropdown['marked'] = $str[6];
    $fold_tmp = array_keys($data);
    $fold_tmp_dsp = hm_folder_dsp($fold_tmp);
    foreach ($fold_tmp as $val) {
        $dropdown[$val] = $str[51].' '.$fold_tmp_dsp[$val].'  ('.$unseen[$val].')';
    }
    $dropdown['page'] = $str[52];
    $page_data['mc'] = hm_print_message_controls2($dropdown, $dest, $simple);
    
    $page_data['lbl_go_folder'] = $str[349];
    $page_data['subject_lbl'] = $str[21];
    $page_data['from_lbl'] = $str[22];
    $page_data['date_lbl'] = $str[23];
    $page_data['size_lbl'] = $str[24];
    /* loop through folders with new mail */
    $out_data = array();
    foreach($data as $folder => $uid_array) {
        $out_folder = array(
            'name' => hm_htmlize($dsp_folders[$folder]),
            'url' => 'mailbox.php?mailbox='.urlencode($folder).
                     '&amp;id='.$hm_input['id'],
            'num_rows' => $unseen[$folder],
            'base64' => base64_encode($folder),
        );
    
        /* fold unfold link */
        if (!isset($folded[$folder])) {
            $out_folder['fold_url'] = 'new.php?id='.$hm_input['id'].'&amp;mailbox='.
                                      urlencode($folder).'&amp;fold='.urlencode($folder);
            $out_folder['fold_type'] = '-';
            $out_folder['fold_title'] = $str[347];
            
            /* get values for new messages in each folder */
            $chk_folder = base64_encode('fold_'.$folder);
            $out_folder['chk_folder'] = $chk_folder;
            $old_t_all = $t_all;
            $old_s_all = $s_all;
            if (isset($_POST['ta_'.base64_encode($folder)])) {
                $t_all = true;
                $s_all = false;
            }
            $out_folder['rows'] = array();
            foreach ($uid_array as $uid => $headers) {
                $out_folder['rows'][] = hm_print_row2($headers, $t_all, $folder,
                             $hm_input['id'], $uid, array(3 => $parents[$folder]), false,
                             $chk_folder, false, false, false, array(), false, $s_all);
            }
            $t_all = $old_t_all;
            $s_all = $old_s_all;
            
        } else {
            $out_folder['fold_url'] = 'new.php?id='.$hm_input['id'].'&amp;mailbox='.
                                      urlencode($folder).'&amp;unfold='.
                                      urlencode($folder);
            $out_folder['fold_type'] = '+';
            $out_folder['fold_title'] = $str[348];
            $out_folder['rows'] = array();
        }
        
        $out_data[] = $out_folder;
    }
    $page_data['folder_data'] = $out_data;
    $page_data['total_viewable_unseen'] = $total_viewable_unseen;
    $page_data['lbl_top'] = $str[324];
    if ($total_viewable_unseen > 15) {
        $top_link = true;
    }
} else {
    $page_data['lbl_top'] = $str[324];
    $page_data['data_found'] = false;
    $page_data['lbl_no_new_msgs'] = $str[53];
}
$page_data['top_link'] = $top_link;
$page_data['start_time'] = $start;
$_SESSION['new_data'] = $data;

/* close imap connection */
hm_imap_logout($imap_stream); 

/* output HTTP headers */
hm_output_http_headers();

/* output page */
if ($simple) {
    hm_output_page($page_data, 'new_template.php', 'simple');
}
else {
    hm_output_page($page_data, 'new_template.php', $template_set);
}

?>
